local addonName, addonTable = ...
local E = addonTable.E
local ui = {}
local elvengine, elvloc, elvpriv, elvprofile, elvglobal
addonTable.E.elvui = ui

local pairs = _G.pairs
local unpack = _G.unpack

function ui:init()
    if _G.ElvUI then
        elvengine, elvloc, elvpriv, elvprofile, elvglobal = unpack(_G.ElvUI);
        if elvengine.private.skins.blizzard.enable == true or elvengine.private.skins.blizzard.character == true then
            self:skinUI()
        end
    end
end

function ui:skinUI()
    -- This is mostly a c/p from ElvUI/Models/skins/character.lua
    local S = elvengine:GetModule('Skins')
    local frame = _G.MultiSpecPaperDollPane
    frame.EquipSet:ClearAllPoints()
    frame.EquipSet:SetPoint("TOPRIGHT")
    frame.EquipSet:SetWidth(frame.EquipSet:GetWidth()-4)
    S:HandleButton(frame.EquipSet)
    for _, object in pairs(frame.buttons) do
        object.BgTop:SetTexture(nil)
        object.BgBottom:SetTexture(nil)
        object.BgMiddle:SetTexture(nil)
        object.icon:Size(36, 36)
        object.icon:SetTexCoord(unpack(elvengine.TexCoords))
        object.icon:Point("LEFT", object, "LEFT", 4, 0)
        _G.hooksecurefunc(object.icon, "SetPoint", function(self, point, attachTo, anchorPoint, xOffset, yOffset, isForced)
            if isForced ~= true then
                self:SetPoint("LEFT", object, "LEFT", 4, 0, true)
            end
        end)
        _G.hooksecurefunc(object.icon, "SetSize", function(self, width, height)
            if width == 30 or height == 30 then
                self:Size(36, 36)
            end
        end)
    end
    S:HandleScrollBar(frame.scrollBar, 5)

    local tab = _G.PaperDollSidebarTab4
    tab.Icon:SetTexCoord(unpack(elvengine.TexCoords))
    tab.Icon:SetHeight(29)
    if not tab.backdrop then
        tab.Highlight:SetColorTexture(1, 1, 1, 0.3)
        tab.Highlight:Point("TOPLEFT", 3, -4)
        tab.Highlight:Point("BOTTOMRIGHT", -1, 0)
        tab.Hider:SetColorTexture(0.4,0.4,0.4,0.4)
        tab.Hider:Point("TOPLEFT", 3, -4)
        tab.Hider:Point("BOTTOMRIGHT", -1, 0)
        tab.TabBg:Kill()
        tab:CreateBackdrop("Default")
        tab.backdrop:Point("TOPLEFT", 1, -2)
        tab.backdrop:Point("BOTTOMRIGHT", 1, -2)
    end
end
